class NodeFilter

# class NodeFilter | Filters are objects that know how to "filter out" nodes. More...
Full name | `DOM::NodeFilter`
Definition | `#include <dom2_traversal.h>`
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum AcceptCode { FILTER_ACCEPT = 1, FILTER_REJECT = 2, FILTER_SKIP = 3 }
- enum ShowCode { SHOW_ALL = 0xFFFFFFFF, SHOW_ELEMENT = 0x00000001, SHOW_ATTRIBUTE = 0x00000002, SHOW_TEXT = 0x00000004, SHOW_CDATA_SECTION = 0x00000008, SHOW_ENTITY_REFERENCE = 0x00000010, SHOW_ENTITY = 0x00000020, SHOW_PROCESSING_INSTRUCTION = 0x00000040, SHOW_COMMENT = 0x00000080, SHOW_DOCUMENT = 0x00000100, SHOW_DOCUMENT_TYPE = 0x00000200, SHOW_DOCUMENT_FRAGMENT = 0x00000400, SHOW_NOTATION = 0x00000800 }

#### Public Methods

- NodeFilter ()
- NodeFilter (const NodeFilter &other)
- virtual NodeFilter & operator = (const NodeFilter &other)
- virtual ~NodeFilter ()
- virtual short acceptNode (const Node &n)
- virtual NodeFilterImpl * handle () const
- virtual bool isNull () const
- void setCustomNodeFilter (CustomNodeFilter *custom)
- CustomNodeFilter * customNodeFilter ()

#### Public Static Methods

- static NodeFilter createCustom (CustomNodeFilter *custom)

#### Protected Methods

- NodeFilter (NodeFilterImpl *i)

#### Protected Members

- NodeFilterImpl *impl

## Detailed Description

Filters are objects that know how to "filter out" nodes. If an Iterator or `TreeWalker` is given a filter, before it returns the next node, it applies the filter. If the filter says to accept the node, the Iterator returns it; otherwise, the Iterator looks for the next node and pretends that the node that was rejected was not there.

The DOM does not provide any filters. Filter is just an interface that users can implement to provide their own filters.

Filters do not need to know how to iterate, nor do they need to know anything about the data structure that is being iterated. This makes it very easy to write filters, since the only thing they have to know how to do is evaluate a single node. One filter may be used with a number of different kinds of Iterators, encouraging code reuse.

To create your own cutsom NodeFilter, define a subclass of CustomNodeFilter which overrides the acceptNode() method and assign an instance of it to the NodeFilter. For more details see the CustomNodeFilter class

NodeFilter () | ### NodeFilter

NodeFilter (const NodeFilter &other) | ### NodeFilter

NodeFilter & operator = (const NodeFilter &other) | ### operator =

[virtual]

~NodeFilter () | ### ~NodeFilter

[virtual]

enum AcceptCode { FILTER_ACCEPT = 1, FILTER_REJECT = 2, FILTER_SKIP = 3 } | ### AcceptCode

The following constants are returned by the acceptNode() method:

enum ShowCode { SHOW_ALL = 0xFFFFFFFF, SHOW_ELEMENT = 0x00000001, SHOW_ATTRIBUTE = 0x00000002, SHOW_TEXT = 0x00000004, SHOW_CDATA_SECTION = 0x00000008, SHOW_ENTITY_REFERENCE = 0x00000010, SHOW_ENTITY = 0x00000020, SHOW_PROCESSING_INSTRUCTION = 0x00000040, SHOW_COMMENT = 0x00000080, SHOW_DOCUMENT = 0x00000100, SHOW_DOCUMENT_TYPE = 0x00000200, SHOW_DOCUMENT_FRAGMENT = 0x00000400, SHOW_NOTATION = 0x00000800 } | ### ShowCode

These are the available values for the whatToShow parameter. They are the same as the set of possible types for Node, and their values are derived by using a bit position corresponding to the value of NodeType for the equivalent node type.

short acceptNode (const Node &n) | ### acceptNode

[virtual]

Test whether a specified node is visible in the logical view of a TreeWalker or NodeIterator. This function will be called by the implementation of TreeWalker and NodeIterator; it is not intended to be called directly from user code.

Parameters:

n | The node to check to see if it passes the filter or not.

Returns: a constant to determine whether the node is accepted, rejected, or skipped, as defined above .

NodeFilterImpl * handle () | ### handle

[const virtual]

not part of the DOM

bool isNull () | ### isNull

[const virtual]

void setCustomNodeFilter (CustomNodeFilter *custom) | ### setCustomNodeFilter

CustomNodeFilter * customNodeFilter () | ### customNodeFilter

NodeFilter createCustom (CustomNodeFilter *custom) | ### createCustom

[static]

NodeFilter (NodeFilterImpl *i) | ### NodeFilter

[protected]

NodeFilterImpl * impl | ### impl

[protected]

Generated by: root on macppc.ports.openbsd.org on Sat Sep 6 10:37:43 2003, using kdoc 2.0a54.